<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_SupplementRelPax ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_SupplementRelPax extends AbstractStructArrayBase
{
    /**
     * The SupplementRelPax
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_SupplementRelPax[]
     */
    public $SupplementRelPax;
    /**
     * Constructor method for ArrayOfJP_SupplementRelPax
     * @uses ArrayOfJP_SupplementRelPax::setSupplementRelPax()
     * @param \StructType\JP_SupplementRelPax[] $supplementRelPax
     */
    public function __construct(array $supplementRelPax = array())
    {
        $this
            ->setSupplementRelPax($supplementRelPax);
    }
    /**
     * Get SupplementRelPax value
     * @return \StructType\JP_SupplementRelPax[]|null
     */
    public function getSupplementRelPax()
    {
        return $this->SupplementRelPax;
    }
    /**
     * This method is responsible for validating the values passed to the setSupplementRelPax method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSupplementRelPax method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSupplementRelPaxForArrayConstraintsFromSetSupplementRelPax(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_SupplementRelPaxSupplementRelPaxItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_SupplementRelPaxSupplementRelPaxItem instanceof \StructType\JP_SupplementRelPax) {
                $invalidValues[] = is_object($arrayOfJP_SupplementRelPaxSupplementRelPaxItem) ? get_class($arrayOfJP_SupplementRelPaxSupplementRelPaxItem) : sprintf('%s(%s)', gettype($arrayOfJP_SupplementRelPaxSupplementRelPaxItem), var_export($arrayOfJP_SupplementRelPaxSupplementRelPaxItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SupplementRelPax property can only contain items of type \StructType\JP_SupplementRelPax, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SupplementRelPax value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_SupplementRelPax[] $supplementRelPax
     * @return \ArrayType\ArrayOfJP_SupplementRelPax
     */
    public function setSupplementRelPax(array $supplementRelPax = array())
    {
        // validation for constraint: array
        if ('' !== ($supplementRelPaxArrayErrorMessage = self::validateSupplementRelPaxForArrayConstraintsFromSetSupplementRelPax($supplementRelPax))) {
            throw new \InvalidArgumentException($supplementRelPaxArrayErrorMessage, __LINE__);
        }
        $this->SupplementRelPax = $supplementRelPax;
        return $this;
    }
    /**
     * Add item to SupplementRelPax value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_SupplementRelPax $item
     * @return \ArrayType\ArrayOfJP_SupplementRelPax
     */
    public function addToSupplementRelPax(\StructType\JP_SupplementRelPax $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_SupplementRelPax) {
            throw new \InvalidArgumentException(sprintf('The SupplementRelPax property can only contain items of type \StructType\JP_SupplementRelPax, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SupplementRelPax[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_SupplementRelPax|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_SupplementRelPax|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_SupplementRelPax|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_SupplementRelPax|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_SupplementRelPax|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SupplementRelPax
     */
    public function getAttributeName()
    {
        return 'SupplementRelPax';
    }
}
